/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package br.com.globalcode.eletronlivre.arduino.serial;

import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;
import gnu.io.UnsupportedCommOperationException;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Enumeration;

/**
 * Ajustes na classe inicial do Vinicius Senger: traducao de strings e
 * opcao de abrir porta informada
 * @author vsenger
 * @author jeffprestes
 */
public class Arduino {

    static boolean init = false;
    static Enumeration portList;
    static CommPortIdentifier portId;
    static String messageString = "10";
    static SerialPort serialPort;
    static OutputStream outputStream;
    static boolean outputBufferEmptyFlag = false;
    static String defaultPort = "COM5";

    public static void delay(long milis) {
        try {
            Thread.sleep(milis);
        } catch (InterruptedException ex) {
        }

    }

    public static void init(String paramPorta) {
        init =true;
        portList = CommPortIdentifier.getPortIdentifiers();

        String porta;

        if (paramPorta==null || paramPorta.trim().length()<4)   {
            porta = defaultPort;
        }   else    {
            porta = paramPorta;
        }

        //System.out.println("Iniciando");
        //System.out.println(portList.);
        while (portList.hasMoreElements()) {
            portId = (CommPortIdentifier) portList.nextElement();
            System.out.println(portId.getName());
            if (portId.getPortType() == CommPortIdentifier.PORT_SERIAL) {
                if (portId.getName().equals(porta)) {
                    System.out.println("Porta encontrada " + porta);
                    try {
                        serialPort = (SerialPort) portId.open("SimpleWriteCOM17", 9600);
                    } catch (Exception e) {
                        System.out.println("Porta em uso.");
                        continue;
                    }


                    try {
                        outputStream = serialPort.getOutputStream();
                        serialPort.setSerialPortParams(9600,
                                SerialPort.DATABITS_8,
                                SerialPort.STOPBITS_1,
                                SerialPort.PARITY_NONE);

                        serialPort.notifyOnOutputEmpty(true);
                    } catch (UnsupportedCommOperationException e) {
                        e.printStackTrace();
                    } catch (IOException e) {
                        e.printStackTrace();
                    } catch (Exception e) {
                        System.out.println("Erro ao definir notificacao de eventos");
                        System.out.println(e.toString());
                    }
                    //90, 0 //no eixo para direita
                    //-90, 0 //no eixo para esquerda
                }
            }
        }


    }

    public static void enviar(byte bytes[]) throws Exception{
        if(!init) init(null);

        System.out.println("Escrevendo...");
        outputStream.write(bytes);

        System.out.println("Esperando...");


        //outputStream.close();
        //serialPort.close();

    }

}
