/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.novatrix.tomada.interruptor;

/**
 *
 * @author jeffprestes
 */
public class Resposta {

    private Status status;
    private PosicaoChave posicaoChave;

    public Resposta(Status status, PosicaoChave posicao)   {
        this.setPosicaoChave(posicao);
        this.setStatus(status);
    }

    /**
     * Gera um objeto resposta a partir da string retornada pelo webservice
     * @param retorno O texto de retorno do webservice. Deve seguir o padrão
     * <inteiro>|<inteiro> onde o primeiro inteiro é o status da resposta e o
     * segundo é o posição do interruptor: ligado ou desligado
     * @return Objeto resposta
     */
    public static Resposta getResposta(String retorno)   {
        if (!retorno.contains("|") || retorno.trim().length()<3)     {
            throw new IllegalArgumentException("O valor a ser informado deve seguir o padrão <inteiro>|<inteiro>");
        }

        retorno = retorno.trim();

        String[] dados = retorno.split("|");

        Status status = Status.ERRO;
        PosicaoChave posicao = PosicaoChave.DESLIGADO;

        //Primeiro campo = status da resposta do webservice
        if (dados[1].equals("0"))   {
            status = Status.ERRO;
        }   else if (dados[1].equals("1"))  {
            status = Status.OK;
        }

        if (dados[3].equals("0"))   {
            posicao = PosicaoChave.DESLIGADO;
        }   else if (dados[3].equals("1"))   {
            posicao = PosicaoChave.LIGADO;
        }

        //System.out.println("dados1:" + dados[1] + " - dados1:" + dados[3]);

        return new Resposta(status, posicao);
    }

    public Status getStatus() {
        return status;
    }

    public void setStatus(Status status) {
        this.status = status;
    }

    public PosicaoChave getPosicaoChave() {
        return posicaoChave;
    }

    public void setPosicaoChave(PosicaoChave posicaoChave) {
        this.posicaoChave = posicaoChave;
    }

    public enum Status  {

        OK(1, "OK"), ERRO(0,"ERRO");

        private Status(int codigo, String descricao) {
            this.codigo = codigo;
            this.descricao = descricao;
        }

        private int codigo;
        private String descricao;

        /**
         * @return the codigo
         */
        public int getCodigo() {
            return codigo;
        }

        /**
         * @return the descricao
         */
        public String getDescricao() {
            return descricao;
        }
    }

    public enum PosicaoChave {

        LIGADO(1, "Ligado"), DESLIGADO(0, "Desligado");

        private PosicaoChave(int codigo, String descricao) {
            this.codigo = codigo;
            this.descricao = descricao;
        }

        private int codigo;
        private String descricao;

        /**
         * @return the codigo
         */
        public int getCodigo() {
            return codigo;
        }

        /**
         * @return the descricao
         */
        public String getDescricao() {
            return descricao;
        }

        
    }
}
